Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointPackingSequenceDecoder3D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointPackingSequenceDecoder3D.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointPackingSequenceDecoder3D.cs	(revision 9596)
@@ -41,17 +41,6 @@
   [Item("Identical bin, three dimensional, extreme points based decoder for the PackingSequence encoding.", "<Description missing...>")]
   [StorableClass]
-  public class ExtremePointPackingSequenceDecoder3D : PackingSolutionDecoder<
-      ThreeDimensionalPacking,
-      CuboidPackingBin,
-      CuboidPackingItem>, I3DPSDecoder {
-
-    public ValueParameter<BoolValue> StackingConstraintsParameter {
-      get { return (ValueParameter<BoolValue>)Parameters["StackingConstraint"]; }
-    }
-
-    public ExtremePointPackingSequenceDecoder3D ()
-      : base() {
-        Parameters.Add(new ValueParameter<BoolValue>("StackingConstraint", "A flag determining whether stackingconstraints should be enforced or not."));
-    }
+  public class ExtremePointPackingSequenceDecoder3D : PackingSolutionDecoder<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>, I3DPSDecoder {
+    public ExtremePointPackingSequenceDecoder3D () : base() {}
     [StorableConstructor]
     protected ExtremePointPackingSequenceDecoder3D (bool deserializing) : base(deserializing) { }
@@ -65,13 +54,8 @@
 
     public override PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, CuboidPackingBin binMeasures, ItemList<CuboidPackingItem> itemMeasures) {
-
       var solution = encodedSolution as PackingSequenceEncoding;
       if (solution == null) throw new InvalidOperationException("Encoding is not of type PackingSequence");
-
-      PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> result = 
-        new PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>(binMeasures);
-
-      result.BinPackings = ThreeDimensionalPackingFunctions.ExtremePointBasedPacking(solution, itemMeasures, binMeasures, StackingConstraintsParameter.Value.Value); 
-
+      PackingPlan3D result = new PackingPlan3D(binMeasures, true, StackingConstraintsParameter.Value.Value);
+      result.Pack(solution, itemMeasures); 
       return result;
     }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ISOContainerMultiComponentVectorDecoder3D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ISOContainerMultiComponentVectorDecoder3D.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ISOContainerMultiComponentVectorDecoder3D.cs	(revision 9596)
@@ -60,128 +60,60 @@
 
     public static PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> Decode(MultiComponentVectorEncoding solution, CuboidPackingBin binMeasures, ItemList<CuboidPackingItem> itemMeasures) {
-      
-      PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> result =
-        new PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>();
-                                                                   /*
-      #region Preperations
-      int nrOfBins = solution.NrOfBins;
-                      
-      Dictionary<int, List<PackingInformation>> unpackedItemIndexesPerBin = new Dictionary<int, List<PackingInformation>>();
-      Dictionary<int, HashSet<ThreeDimensionalPacking>> extremePointsForBin = new Dictionary<int, HashSet<ThreeDimensionalPacking>>();  
-      ObservableDictionary<int, CuboidPackingBin> resultingBinMeasures = new ObservableDictionary<int, CuboidPackingBin>();
-      var occupiedPoints = new List<int[, ,]>();
+      PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> resultPlan = new PackingPlan3D(binMeasures);
+      ObservableList<BinPacking3D> result = new ObservableList<BinPacking3D>();
 
-      for (int i = 0; i < nrOfBins; i++) {
-        unpackedItemIndexesPerBin[i] = new List<PackingInformation>(solution.PackingInformations[i]);
+      var sequenceMatrix = solution.GenerateSequenceMatrix();
+      Dictionary<int, bool> rotated = solution.GenerateRotationArray();
 
-        extremePointsForBin[i] = new HashSet<ThreeDimensionalPacking>();
-        extremePointsForBin[i].Add(new ThreeDimensionalPacking(i, 0, 0, 0, false));
-        occupiedPoints = ExtremePointsFunctions3D.IncreaseBinCountForOccupiedPoints(occupiedPoints, binMeasures);
-        resultingBinMeasures[i] = new CuboidPackingBin(binMeasures.Width, binMeasures.Height, binMeasures.Depth);
+      //Fill bins according to grouping vector
+      List<int> remainingIDs = new List<int>();
+      foreach (var sequence in sequenceMatrix) {
+        remainingIDs = remainingIDs.Concat(sequence).ToList();
+        var bp = new BinPacking3D(binMeasures);
+        bp.ExtremePointBasedPacking(ref remainingIDs, itemMeasures, true, rotated);
+        if (remainingIDs.Count > 0) {
+          bp.DoubleDepth();
+          bp.ExtremePointBasedPacking(ref remainingIDs, itemMeasures, true, rotated);
+        }
+        result.Add(bp);
       }
+      result.RemoveAll(x => x.ItemPositions.Count == 0);
+      result = new ObservableList<BinPacking3D>(result.OrderByDescending(bp => bp.PackingDensity));
 
-      ObservableDictionary<int, ThreeDimensionalPacking> itemPositions = new ObservableDictionary<int, ThreeDimensionalPacking>();
-      var remainingItems = new List<PackingInformation>();
-
-      #endregion Preperations
-
-
-      //Iterate over all bin-lists
-      for (int binNr = 0; binNr < nrOfBins; binNr++) {
-        //Iterate over the current bin-item-list and find feasible positions in the current bin for each item
-        var unpackedItems = unpackedItemIndexesPerBin[binNr];
-        for (int i = 0; i < unpackedItems.Count; i++) {
-          var itemIndex = unpackedItems[i].ItemID;
-          var item = itemMeasures[itemIndex];
-
-          extremePointsForBin[binNr] = ExtremePointsFunctions3D.OrderExtremePoints(extremePointsForBin[binNr], occupiedPoints, resultingBinMeasures[binNr]);
-          var positionFound = ExtremePointsFunctions3D.FindExtremePointForItemUsingMaterialAndWeightConstraint(itemIndex, itemMeasures, resultingBinMeasures[binNr], extremePointsForBin[binNr], occupiedPoints, itemPositions, unpackedItems[i].Rotated);
-
-          if (positionFound == null && resultingBinMeasures[binNr].Depth.Equals(binMeasures.Depth)) {
-            occupiedPoints = DoubleDepthForBinNr(occupiedPoints, ref resultingBinMeasures, binNr);
-            positionFound = ExtremePointsFunctions3D.FindExtremePointForItemUsingMaterialAndWeightConstraint(itemIndex, itemMeasures, resultingBinMeasures[binNr], extremePointsForBin[binNr], occupiedPoints, itemPositions, unpackedItems[i].Rotated);
-          } 
-
-          if (positionFound != null) {
-            extremePointsForBin[binNr].Remove(positionFound);
-            itemPositions[itemIndex] = positionFound;
-            occupiedPoints = ExtremePointsFunctions3D.OccupyPointsForNewItem(occupiedPoints, item, positionFound, itemIndex);
-            extremePointsForBin[binNr] = ExtremePointsFunctions3D.GenerateNewExtremePointsForNewItem(extremePointsForBin[binNr], occupiedPoints, item, positionFound, resultingBinMeasures[binNr]);
-          } else {
-            remainingItems.Add(unpackedItems[i]);
-            solution.PackingInformations[binNr].Remove(unpackedItems[i]);
+      //Try to put remaining items in existing bins
+      var temp = new List<int>(remainingIDs);
+      foreach (int id in temp) {
+        foreach (var bp in result) {
+          var position = bp.FindExtremePointForItem(itemMeasures[id], rotated[id], true);
+          if (remainingIDs.Count > 0) {
+            bp.DoubleDepth();
+            position = bp.FindExtremePointForItem(itemMeasures[id], rotated[id], true);
+          }
+          if (position != null) {
+            bp.PackItem(id, itemMeasures[id], position);
+            remainingIDs.Remove(id);
           }
         }
       }
 
-
-      //Packing of remaining items    
-      //Iterate over all bin-lists
-      for (int binNr = 0; binNr < nrOfBins && remainingItems.Count > 0; binNr++) {
-        var unpackedItems = new List<PackingInformation>(remainingItems);
-        //Iterate over all the remaining items
-        for (int i = 0; i < unpackedItems.Count; i++) {
-          var itemIndex = unpackedItems[i].ItemID;
-          var item = itemMeasures[itemIndex];
-
-          extremePointsForBin[binNr] = ExtremePointsFunctions3D.OrderExtremePoints(extremePointsForBin[binNr], occupiedPoints, resultingBinMeasures[binNr]);
-          var positionFound = ExtremePointsFunctions3D.FindExtremePointForItemUsingMaterialAndWeightConstraint(itemIndex, itemMeasures, resultingBinMeasures[binNr], extremePointsForBin[binNr], occupiedPoints, itemPositions, unpackedItems[i].Rotated);
-
-
-          if (positionFound == null && resultingBinMeasures[binNr].Depth.Equals(binMeasures.Depth)) {
-            occupiedPoints = DoubleDepthForBinNr(occupiedPoints, ref resultingBinMeasures, binNr);
-            positionFound = ExtremePointsFunctions3D.FindExtremePointForItemUsingMaterialAndWeightConstraint(itemIndex, itemMeasures, resultingBinMeasures[binNr], extremePointsForBin[binNr], occupiedPoints, itemPositions, unpackedItems[i].Rotated);
-          } 
-          
-          if (positionFound != null) {
-            extremePointsForBin[binNr].Remove(positionFound);
-            itemPositions[itemIndex] = positionFound;
-            occupiedPoints = ExtremePointsFunctions3D.OccupyPointsForNewItem(occupiedPoints, item, positionFound, itemIndex);
-            extremePointsForBin[binNr] = ExtremePointsFunctions3D.GenerateNewExtremePointsForNewItem(extremePointsForBin[binNr], occupiedPoints, item, positionFound, resultingBinMeasures[binNr]);
-            remainingItems.Remove(unpackedItems[i]);
-            solution.PackingInformations[binNr].Add(unpackedItems[i]);
-          }
+      //Put still remaining items in new bins
+      while (remainingIDs.Count > 0) {
+        var bp = new BinPacking3D(binMeasures);
+        bp.ExtremePointBasedPacking(ref remainingIDs, itemMeasures, true, rotated);
+        if (remainingIDs.Count > 0) {
+          bp.DoubleDepth();
+          bp.ExtremePointBasedPacking(ref remainingIDs, itemMeasures, true, rotated);
         }
-        if (remainingItems.Count > 0 && binNr + 1 >= nrOfBins) {
-          extremePointsForBin[nrOfBins] = new HashSet<ThreeDimensionalPacking>();
-          extremePointsForBin[nrOfBins].Add(new ThreeDimensionalPacking(nrOfBins, 0, 0, 0, false));
-          occupiedPoints = ExtremePointsFunctions3D.IncreaseBinCountForOccupiedPoints(occupiedPoints, binMeasures);
-          resultingBinMeasures[nrOfBins] = new CuboidPackingBin(binMeasures.Width, binMeasures.Height, binMeasures.Depth);
-          solution.PackingInformations[nrOfBins] = new ItemList<PackingInformation>();
-          nrOfBins++;
-        }
+        result.Add(bp);
       }
-
-      result.BinPackings = BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>.GetBinPackings(itemPositions, resultingBinMeasures, itemMeasures, nrOfBins);   */
-      return result;
-    }
-
-    private static List<int[, ,]> DoubleDepthForBinNr(List<int[, ,]> occupiedPoints, ref ObservableDictionary<int, CuboidPackingBin> binMeasures, int binNr) {
-      var oldDepth = binMeasures[binNr].Depth;
-      binMeasures[binNr].Depth = binMeasures[binNr].Depth * 2;
-      var newBinOccupation = new int[binMeasures[binNr].Width, binMeasures[binNr].Height, binMeasures[binNr].Depth];
-      for (int w = 0; w < binMeasures[binNr].Width; w++) {
-        for (int h = 0; h < binMeasures[binNr].Height; h++) {
-          for (int d = 0; d < binMeasures[binNr].Depth; d++) {
-            if (d < oldDepth)
-              newBinOccupation[w, h, d] = occupiedPoints[binNr][w, h, d];
-            else
-              newBinOccupation[w, h, d] = -1;
-          }
-        }
-      }
-
-      occupiedPoints[binNr] = newBinOccupation;
-      return occupiedPoints;
+      result.RemoveAll(x => x.ItemPositions.Count == 0); 
+      resultPlan.BinPackings = new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>(result.OrderByDescending(bp => bp.PackingDensity));
+      return resultPlan;
     }
 
 
-
-
     public override PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, CuboidPackingBin binMeasures, ItemList<CuboidPackingItem> itemMeasures) {
-
       var solution = encodedSolution as MultiComponentVectorEncoding;
       if (solution == null) throw new InvalidOperationException("Encoding is not of type MultiComponentVector");
-
       return Decode(solution, binMeasures, itemMeasures);
     }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/PackingSolutionDecoder.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/PackingSolutionDecoder.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/PackingSolutionDecoder.cs	(revision 9596)
@@ -59,4 +59,7 @@
       get { return (ILookupParameter<PackingPlan<D, B, I>>)Parameters["PackingPlan"]; }
     }
+    public ValueParameter<BoolValue> StackingConstraintsParameter {
+      get { return (ValueParameter<BoolValue>)Parameters["StackingConstraint"]; }
+    }
 
 
@@ -67,4 +70,5 @@
       Parameters.Add(new LookupParameter<ItemList<I>>("PackingItemMeasures", "Packing-item data taken from the bin-packing problem-instance."));
       Parameters.Add(new LookupParameter<B>("PackingBinMeasures", "Packing-bin data taken from the bin-packing problem-instance."));
+      Parameters.Add(new ValueParameter<BoolValue>("StackingConstraint", "A flag determining whether stackingconstraints should be enforced or not."));
     }
 
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints.cs	(revision 9596)
@@ -33,12 +33,13 @@
   [Item("Occupated Points", "A datastructure holding all currently occupied points of a packing-bin.")]
   [StorableClass]
-  public abstract class OccupiedPoints<D, I> : Item
+  public abstract class OccupiedPoints<D, B, I> : Item
     where D : class, IPackingDimensions
+    where B : PackingShape<D>, IPackingBin
     where I : PackingShape<D>, IPackingItem {
 
-    public OccupiedPoints() : base() { }
+    public OccupiedPoints(B binMeasures) : base() { }
     [StorableConstructor]
     protected OccupiedPoints(bool deserializing) : base(deserializing) { }
-    protected OccupiedPoints(OccupiedPoints<D,I> original, Cloner cloner)
+    protected OccupiedPoints(OccupiedPoints<D,B,I> original, Cloner cloner)
       : base(original, cloner) {
     }
@@ -51,5 +52,5 @@
     public abstract bool IsStaticStable(I item, D ep);
     public abstract bool WeightIsSupported(I item, D ep, ItemList<I> items);
-  
+    public abstract void ChangeBinMeasures(B binMeasures);
   }
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints2D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints2D.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints2D.cs	(revision 9596)
@@ -35,10 +35,10 @@
   [Item("Occupated Points 2D", "A datastructure holding all currently occupied points of a 2D packing-bin.")]
   [StorableClass]
-  public class OccupiedPoints2D : OccupiedPoints<TwoDimensionalPacking, RectangularPackingItem> {
+  public class OccupiedPoints2D : OccupiedPoints<TwoDimensionalPacking, RectangularPackingBin, RectangularPackingItem> {
                    
     [Storable]
     private int[,] occupiedPoints { get; set; }
 
-    public OccupiedPoints2D(RectangularPackingBin binMeasures) : base() {
+    public OccupiedPoints2D(RectangularPackingBin binMeasures) : base(binMeasures) {
       occupiedPoints = new int[binMeasures.Width, binMeasures.Height];
       for (int w = 0; w < binMeasures.Width; w++) {
@@ -67,5 +67,4 @@
       return true;
     }
-
     public override void OccupyPoints(RectangularPackingItem measures, TwoDimensionalPacking position, int itemID) {
       int width = position.Rotated ? measures.Height : measures.Width;
@@ -77,9 +76,7 @@
       }
     }
-
     public override bool IsPointOccupied(TwoDimensionalPacking point) {
       return occupiedPoints[point.X, point.Y] != -1;
     }
-
     public override int ShortestPossibleSideFromEP(TwoDimensionalPacking ep) {
       int shortestSide = int.MaxValue;
@@ -102,13 +99,15 @@
       return shortestSide;
     }
-
     public override bool IsStaticStable(RectangularPackingItem item, TwoDimensionalPacking ep) {
       //For the current implementation there was no need for stacking-constraints in the 2D-case. 
       //But it could be interesting for shelf-packing applications!
-      return true;
+      throw new NotImplementedException();
     }
     public override bool WeightIsSupported(RectangularPackingItem item, TwoDimensionalPacking ep, ItemList<RectangularPackingItem> items) {
       return true;
     }
+    public override void ChangeBinMeasures(RectangularPackingBin binMeasures) {
+      throw new NotImplementedException();
+    }
   }
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints3D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints3D.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/OccupiedPoints3D.cs	(revision 9596)
@@ -35,10 +35,10 @@
   [Item("Occupied Points 3D", "A datastructure holding all currently occupied points of a 3D packing-bin.")]
   [StorableClass]
-  public class OccupiedPoints3D : OccupiedPoints<ThreeDimensionalPacking, CuboidPackingItem> {
+  public class OccupiedPoints3D : OccupiedPoints<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> {
 
     [Storable]
     private int[, ,] occupiedPoints { get; set; }
 
-    public OccupiedPoints3D(CuboidPackingBin binMeasures) {
+    public OccupiedPoints3D(CuboidPackingBin binMeasures) : base(binMeasures) {
       occupiedPoints = new int[binMeasures.Width, binMeasures.Height, binMeasures.Depth];
       for (int w = 0; w < binMeasures.Width; w++) {
@@ -71,5 +71,4 @@
       return true;
     }
-
     public override void OccupyPoints(CuboidPackingItem measures, ThreeDimensionalPacking position, int itemID) {
       int width = position.Rotated ? measures.Depth : measures.Width;
@@ -83,9 +82,7 @@
       }
     }
-
     public override bool IsPointOccupied(ThreeDimensionalPacking point) {
       return occupiedPoints[point.X, point.Y, point.Z] != -1;
     }
-
     public override int ShortestPossibleSideFromEP(ThreeDimensionalPacking ep) {
       int shortestSide = int.MaxValue;
@@ -114,6 +111,4 @@
       return shortestSide;
     }
-
-
     public override bool IsStaticStable(CuboidPackingItem item, ThreeDimensionalPacking ep) {
       //Static stability is given, if item is placed on the ground
@@ -164,5 +159,19 @@
       return false;
     }
-  
+    public override void ChangeBinMeasures(CuboidPackingBin binMeasures) {
+      int oldDepth = occupiedPoints.GetLength(2);
+      var newBinOccupation = new int[binMeasures.Width, binMeasures.Height, binMeasures.Depth];
+      for (int w = 0; w < binMeasures.Width; w++) {
+        for (int h = 0; h < binMeasures.Height; h++) {
+          for (int d = 0; d < binMeasures.Depth; d++) {
+            if (d < oldDepth)
+              newBinOccupation[w, h, d] = occupiedPoints[w, h, d];
+            else
+              newBinOccupation[w, h, d] = -1;
+          }
+        }
+      }
+      occupiedPoints = newBinOccupation;
+    }
   }
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/ThreeDimensionalPacking.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/ThreeDimensionalPacking.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/ThreeDimensionalPacking.cs	(revision 9596)
@@ -81,4 +81,24 @@
       return base.GetHashCode() + 13 * X + 17 * Y + 23 * Z;
     }
+
+    public static ThreeDimensionalPacking MoveLeft(ThreeDimensionalPacking original) {
+      return new ThreeDimensionalPacking(original.AssignedBin, original.X - 1, original.Y, original.Z, original.Rotated);
+    }
+    public static ThreeDimensionalPacking MoveDown(ThreeDimensionalPacking original) {
+      return new ThreeDimensionalPacking(original.AssignedBin, original.X, original.Y - 1, original.Z, original.Rotated);
+    }
+    public static ThreeDimensionalPacking MoveBack(ThreeDimensionalPacking original) {
+      return new ThreeDimensionalPacking(original.AssignedBin, original.X, original.Y, original.Z - 1, original.Rotated);
+    }
+
+    public static ThreeDimensionalPacking MoveRight(ThreeDimensionalPacking original) {
+      return new ThreeDimensionalPacking(original.AssignedBin, original.X + 1, original.Y, original.Z, original.Rotated);
+    }
+    public static ThreeDimensionalPacking MoveUp(ThreeDimensionalPacking original) {
+      return new ThreeDimensionalPacking(original.AssignedBin, original.X, original.Y + 1, original.Z, original.Rotated);
+    }
+    public static ThreeDimensionalPacking MoveFront(ThreeDimensionalPacking original) {
+      return new ThreeDimensionalPacking(original.AssignedBin, original.X, original.Y, original.Z + 1, original.Rotated);
+    }
   }
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/TwoDimensionalPacking.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/TwoDimensionalPacking.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Dimensions/TwoDimensionalPacking.cs	(revision 9596)
@@ -77,4 +77,19 @@
       return base.GetHashCode() + 13 * X + 17 * Y;
     }
+
+    public static TwoDimensionalPacking MoveLeft(TwoDimensionalPacking original) {
+      return new TwoDimensionalPacking(original.AssignedBin, original.X - 1, original.Y, original.Rotated);
+    }
+    public static TwoDimensionalPacking MoveDown(TwoDimensionalPacking original) {
+      return new TwoDimensionalPacking(original.AssignedBin, original.X, original.Y - 1, original.Rotated);
+    }
+
+    public static TwoDimensionalPacking MoveRight(TwoDimensionalPacking original) {
+      return new TwoDimensionalPacking(original.AssignedBin, original.X + 1, original.Y, original.Rotated);
+    }
+    public static TwoDimensionalPacking MoveUp(TwoDimensionalPacking original) {
+      return new TwoDimensionalPacking(original.AssignedBin, original.X, original.Y + 1, original.Rotated);
+    }
+
   }
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/GroupingVector/GroupingVectorEncoding.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/GroupingVector/GroupingVectorEncoding.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/GroupingVector/GroupingVectorEncoding.cs	(revision 9596)
@@ -20,4 +20,6 @@
 #endregion
 
+using System.Collections.Generic;
+using System.Linq;
 using System.Text;
 using HeuristicLab.Common;
@@ -50,4 +52,17 @@
         GroupingVector = new IntegerVector();
     }
+
+    public List<List<int>> GenerateSequenceMatrix() {
+      List<List<int>> result = new List<List<int>>();
+      int nrOfBins = GroupingVector.Max() + 1;
+      for (int i = 0; i < nrOfBins; i++)
+        result.Add(new List<int>());
+      for (int i = 0; i < GroupingVector.Length; i++) {
+        result[GroupingVector[i]].Add(i);
+      }
+      return result;
+    }
+    
+
 
     public override string ToString() {
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/BinBasedMultiComponentVectorCrossover.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/BinBasedMultiComponentVectorCrossover.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/BinBasedMultiComponentVectorCrossover.cs	(revision 9596)
@@ -33,36 +33,40 @@
   public class BinBasedMultiComponentVectorCrossover :  MultiComponentVectorCrossover {
     [StorableConstructor]
-    protected BinBasedMultiComponentVectorCrossover (bool deserializing) : base(deserializing) { }
-    protected BinBasedMultiComponentVectorCrossover (BinBasedMultiComponentVectorCrossover  original, Cloner cloner) : base(original, cloner) { }
-    public BinBasedMultiComponentVectorCrossover ()
+    protected BinBasedMultiComponentVectorCrossover(bool deserializing) : base(deserializing) { }
+    protected BinBasedMultiComponentVectorCrossover(BinBasedMultiComponentVectorCrossover original, Cloner cloner) : base(original, cloner) { }
+    public BinBasedMultiComponentVectorCrossover()
       : base() {
     }
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new BinBasedMultiComponentVectorCrossover (this, cloner);
+      return new BinBasedMultiComponentVectorCrossover(this, cloner);
     }
 
     public override MultiComponentVectorEncoding Cross(IRandom random, MultiComponentVectorEncoding parent1, MultiComponentVectorEncoding parent2) {
-      MultiComponentVectorEncoding child = new MultiComponentVectorEncoding();
+      MultiComponentVectorEncoding child = new MultiComponentVectorEncoding ();
+
       int nrOfItems = parent1.NrOfItems;
       bool[] itemAlreadyAssigned = new bool[nrOfItems];
-
-      bool useParent2 = false;
       int nrOfBins = parent1.NrOfBins > parent2.NrOfBins ? parent2.NrOfBins : parent1.NrOfBins;
 
+      //Add one bin from parent1
+      int swappedBinNr = random.Next(nrOfBins);
+      var swappedBin = new ItemList<PackingInformation>();
+      for (int i = 0; i < parent1.PackingInformations[swappedBinNr].Count; i++) {
+        PackingInformation pi = new PackingInformation(parent1.PackingInformations[swappedBinNr][i]);
+        if (!itemAlreadyAssigned[pi.ItemID]) {
+          itemAlreadyAssigned[pi.ItemID] = true;
+          swappedBin.Add(new PackingInformation(pi));
+        }
+      }
+      child.PackingInformations[swappedBinNr] = swappedBin;
 
+      //Get the remaining bins from parent2
       for (int binNr = 0; binNr < nrOfBins; binNr++) {
-        MultiComponentVectorEncoding currentParent1 = useParent2 ? parent2 : parent1;
-        MultiComponentVectorEncoding currentParent2 = useParent2 ? parent1 : parent2;
-
-
-        var newBin = new ItemList<PackingInformation>();
-        double crossPointPercent = 0;
-
-        int nrOfItems1 = currentParent1.PackingInformations[binNr].Count;
-        if (nrOfItems1 > 0) {
-          double crossPoint1 = random.Next(nrOfItems1);
-          crossPointPercent = crossPoint1 / nrOfItems1;
-          for (int i = 0; i < crossPoint1; i++) {
-            PackingInformation pi = new PackingInformation(currentParent1.PackingInformations[binNr][i]);
+        if (binNr != swappedBinNr) {
+          var newBin = new ItemList<PackingInformation>();
+          var currentParent = parent2;
+          int nrOfItemsInBin = currentParent.PackingInformations[binNr].Count;
+          for (int i = 0; i < nrOfItemsInBin; i++) {
+            PackingInformation pi = new PackingInformation(currentParent.PackingInformations[binNr][i]);
             if (!itemAlreadyAssigned[pi.ItemID]) {
               itemAlreadyAssigned[pi.ItemID] = true;
@@ -70,22 +74,9 @@
             }
           }
+          child.PackingInformations[binNr] = newBin;
         }
-
-        int nrOfItems2 = currentParent2.PackingInformations[binNr].Count;
-        if (nrOfItems2 > 0) {
-          int crossPoint2 = Convert.ToInt32(nrOfItems2 * crossPointPercent);
-          for (int i = crossPoint2; i < nrOfItems2; i++) {
-            PackingInformation pi = new PackingInformation(currentParent2.PackingInformations[binNr][i]);
-            if (!itemAlreadyAssigned[pi.ItemID]) {
-              itemAlreadyAssigned[pi.ItemID] = true;
-              newBin.Add(new PackingInformation(pi));
-            }
-          }
-        }
-
-        child.PackingInformations[binNr] = newBin;
-        useParent2 = !useParent2;
       }
 
+      //Pack still remaining items in bin#0
       for (int itemID = 0; itemID < nrOfItems; itemID++) {
         if (!itemAlreadyAssigned[itemID])
@@ -93,5 +84,5 @@
       }
 
-      
+
       return child;
     }       
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorEncoding.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorEncoding.cs	(revision 9595)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/MultiComponentVectorEncoding.cs	(revision 9596)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using System.Text;
 using HeuristicLab.Collections;
@@ -64,5 +65,26 @@
       : base() {
         PackingInformations = new ObservableDictionary<int, ItemList<PackingInformation>>();
-    }       
+    }
+
+    public List<List<int>> GenerateSequenceMatrix() {
+      List<List<int>> result = new List<List<int>>();
+      foreach (var bi in PackingInformations) {
+        var temp = new List<int>();
+        foreach (var piEntry in bi.Value) {
+          temp.Add(piEntry.ItemID);
+        }
+        result.Add(temp);
+      }
+      return result;
+    }
+    public Dictionary<int, bool> GenerateRotationArray() {
+      Dictionary<int, bool> result = new Dictionary<int, bool>();
+      foreach (var bi in PackingInformations)
+        foreach (var pi in bi.Value)
+          result[pi.ItemID] = pi.Rotated;
+      return result;
+    }
+
+
 
     public override string ToString() {
